// Reads the state of 6 Buttons and one poti and sends a serial message about their states

#include <SoftwareSerial.h>

#define RX              0
#define TX              1
#define ANAIN          A2
#define DIGIN_1         3
#define DIGIN_2         4
#define DIGIN_3         5
#define DIGIN_4         6
#define DIGIN_5         7
#define DIGIN_6         8

SoftwareSerial SoftSerial(RX, TX);

void setup() {
  SoftSerial.begin(9600);
  for( int i=DIGIN_1 ; i<=DIGIN_6 ; i++ ){
    pinMode(i, INPUT_PULLUP);
  }
}

void loop() {
  byte buttonState;
  int  sensorValue;
  unsigned int checksumSum = 0;
  byte checksum;

  for( int i=DIGIN_1 ; i<=DIGIN_6 ; i++ ){
    buttonState = digitalRead(i);
    if (buttonState == LOW) {
      SoftSerial.print(1);
      checksumSum++;
    }
    else {
      SoftSerial.print(0);
    }
  }
  sensorValue = analogRead(ANAIN);
  checksumSum = checksumSum + sensorValue;

  // add leading zeros before sensorValue
  if      (sensorValue < 10) {
    SoftSerial.print("000");
  }
  else if (sensorValue < 100) {
    SoftSerial.print("00");
  }
  else if (sensorValue < 1000) {
    SoftSerial.print("0");
  }

  SoftSerial.print(sensorValue);
  checksum = checksumSum % 9;
  SoftSerial.println(checksum);
  delay(50);
}





