#!/usr/bin/python
# -*- coding: UTF-8 -*-

# This programm prepares an USB stick with mp3 folders to be read by BReaBox and the
# BReabox soundsamples for navigation

# ########################### Changeable Constants ############################

# This Programm can either do one of the following things
# "General Voiceoutputs" That creates the Soundfiles that are on the BReabox for
#                        Navigation
# "Booktitles on Stick"  That creates one Soundfile per booktitle in the folder of
#                        each Book

strPrepareAction = "General Voiceoutputs"

# strText2SpeechFolder = "/home/pi/allgemeine_sprachausgaben/"

strText2SpeechFolder = "/Users/stefanstechert/Linguatec/"

strBooksFolder = "/Users/stefanstechert/Desktop/stick_prepare_linguatec/"

strUSBStickPrepared = "Stick_ist_vorbereitet.txt"

strReadRobot = "Linguatec" # "Google" "Linguatec" "Pico" "Apple" 
b32kHz = False

strLanguagePico      = "--lang=de-DE"
strLanguageGoogle    = "de"


# ########################### Imports #########################################
import subprocess
import time

import urllib
from urllib import FancyURLopener


# ########################### Stuff for Internetaccess ############################
# Change the urllib standard user agent which is not accepted by Google
class UrlOpener(FancyURLopener):
	version = "Mozilla/5.0 (Windows; U; Windows NT 5.1; it; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11"

# Object from Class
objUrlOpener = UrlOpener()


# ########################### Preparation of the pi ############################

# I downloaded:
# 2015-05-05-raspbian-wheezy.zip (MD5: 7db16829ff3208c2235c0bef65b06201 SHA1:cb799af077930ff7cbcfaa251b4c6e25b11483de)
# cirrus-linux-3.18.16.tgz (MD5: ce8bfc7487cb815645d3f30c00161685)
# pico2wave.deb (MD5: b530eb9ff97b9cf079f622efe46ce513)
#
# diskutil list
# my SD was disk2 and formatted as FAT32
# sudo diskutil unmount /dev/disk2s1
# sudo dd if=2015-05-05-raspbian-wheezy.img of=/dev/disk2 bs=1m
#
# First start of Raspi:
# sudo raspi-config
# Keyboard german and Boot to graphical system -> Reboot
# Rest Easier from Mac:
# ssh pi@192.168.178.40
# Maybe:
# ssh-keygen -f "/Users/stefanstechert/.ssh/known_hosts" -R 192.168.178.40
# 
# cd /
# sudo tar -xvzf path-to-the-tgz-file
# 
# sudo nano /boot/config.txt
# add lines at end:
# dtoverlay=rpi-cirrus-wm5102-overlay
# dtoverlay=i2s-mmap
# 
# sudo nano /etc/modprobe.d/raspi-blacklist.conf
# add lines at end:
# softdep arizona-spi pre: arizona-ldo1 
# softdep spi-bcm2708 pre: fixed 
# softdep spi-bcm2835 pre: fixed
#
# sudo apt-get update
# sudo apt-get install xmms2 alsa-utils xmms2-plugin-all lame python-serial mplayer
# sudo dpkg -i pico2wave.deb
#
# sudo nano /boot/cmdline.txt
# following line:
# dwc_otg.lpm_enable=0 console=ttyAMA0,115200 kgdboc=ttyAMA0,115200 console=tty1 root=/dev/mmcblk0p2 rootfstype=ext4 elevator=deadline rootwait
# should be changed to:
# dwc_otg.lpm_enable=0 console=tty1 root=/dev/mmcblk0p2 rootfstype=ext4 elevator=deadline rootwait
#
# sudo nano /etc/inittab
# following line (EOF):
# T0:23:respawn:/sbin/getty -L ttyAMA0 115200 vt100
# should be changed to:
# #T0:23:respawn:/sbin/getty -L ttyAMA0 115200 vt100
# sudo apt-get remove wolfram-engine
# chmod +x *.sh
# 
# sudo nano /etc/xdg/lxsession/LXDE-pi/autostart
# add line:
# lxterminal -e /home/pi/BReaBox_starter.sh
# 
# sudo nano /etc/rc.local
# add line before line exit 0:
# sudo cp /home/pi/asoundrc_modified /home/pi/.asoundrc
# 
# mkdir use_case_scripts
# cd use_case_scripts
# git clone --depth 1 https://github.com/CirrusLogic/wiki-content.git
# mv wiki-content/scripts/* ~/use_case_scripts/
# chmod +x use_case_scripts/*.sh
#
# sudo nano use_case_scripts/Playback_to_Headset.sh
# following line:
# amixer $1 -Dhw:sndrpiwsp cset name='HPOUT1 Digital Volume' 116
# should be changed to:
# amixer $1 -Dhw:sndrpiwsp cset name='HPOUT1 Digital Volume' 10
#
# sudo nano use_case_scripts/Playback_to_Speaker.sh
# following line:
# amixer $1 -Dhw:sndrpiwsp cset name='Speaker Digital Volume' 128
# should be changed to:
# amixer $1 -Dhw:sndrpiwsp cset name='Speaker Digital Volume' 10
#
# chmod +x sfk
# sudo mv sfk /usr/bin/
#
# sudo reboot
#
# without wolfson(?):
# sudo modprobe snd_bcm2835
# sudo amixer cset numid=3 1
# sudo reboot 
#
# all maybe useless (?):
# ------------------
# Safety copy of SD Card:
# sudo dd if=/dev/rdisk1 of=working_version.img bs=1m
# Restore safety copy (unmount first):
# sudo dd if=working_version.img of=/dev/rdisk1 bs=1m
#
# Screensaver:
# sudo nano /etc/xdg/lxsession/LXDE-pi/autostart
# 
# # @xscreensaver -no-splash
# @xset s noblank
# @xset s off
# @xset -dpms
#
# chmod +x stop
# sudo mv stop /usr/bin/
#
# mplayer -ao alsa:device=hw=0.0 005.mp3
# sudo apt-get --purge remove pulseaudio
# sudo apt-get install python-pip;sudo pip install mutagen
# sudo apt-get install libsamplerate0 lxmusic alsa-oss minicom
# sudo minicom -b 9600 -o -D /dev/ttyAMA0
# hardware flow control off
# sudo stty 9600 -F /dev/ttyAMA0
# cat /dev/ttyAMA0
# sudo systemctl disable serial-getty@ttyAMA0.service
# sudo modprobe snd_pcm_oss
# sudo modprobe snd_mixer_oss
# amixer contents | grep numid
# amixer cget numid=159
#
# How any stick is prepared:
# --------------------------
# format a usb stick with FAT32 and name it "STICK"
# create folders on it with the following naming convention
# Name of the author - Name of the book
# or just the name of the book might be quicker to be spoken (regex: .* -[ ])
# place the belonging mp3s in the folders
# they have to be named 001.mp3 ... 999.mp3
# if there are less than 999 it's okay, but not more

# ########################### Functions begin #################################

# ----------------------------------------------------------------------------
# Filter out the text between a start and an end expression
# ----------------------------------------------------------------------------
def filterOutText(strText,strStart,strEnd):
	bValid = True
	if not(len(strText) < (len(strStart) + len(strEnd))):
		if (strText.find(strStart) >= 0) and (strText.find(strEnd) >= 0):
			numStartPos = strText.find(strStart) + len(strStart)
			numEndPos = strText.find(strEnd)
			if numStartPos > numEndPos:
				bValid = False
		else:
			bValid = False
	else:
			bValid = False

	if bValid:
		return strText[numStartPos:numEndPos]
	else:
		return ""


# ----------------------------------------------------------------------------
# reads a given text but instead outputting to speaker - it saves as MP3
# ----------------------------------------------------------------------------
def readAsMP3(strText,strDestinationPath,b32kHz,strRobot):
	global strLanguagePico
	global strLanguageGoogle
	
	if strRobot == "Pico": # ------------------------------------------------------
		# pico2wave --lang=de-DE --wave=test.wav "Das Grass ist grüner als draußen"
		# lame -V2 -a --vbr-new --resample 32 test.wav test.mp3
		subprocess.check_output(["pico2wave",strLanguagePattern,"--wave=temp.wav","\"" + strText + "\""])
		
		# .wav to .mp3
		if b32kHz:
			subprocess.check_output(["lame","-V2","-a","--vbr-new","--resample","32","temp.wav",strDestinationPath])
		else:
			subprocess.check_output(["lame","-V2","-a","--vbr-new","temp.wav",strDestinationPath])
			
		subprocess.check_output(["rm","temp.wav"])

	elif strRobot == "Google": # ------------------------------------------------------
		# https://translate.google.de/translate_tts?ie=UTF-8&q=hallo%20welt&tl=de&total=1&idx=0&textlen=10&tk=3|3&client=t&prev=input&ttsspeed=1
		# splitted:
		# https://translate.google.de/translate_tts?ie=UTF-8&
		# q=hallo%20welt
		# &tl=de
		# &total=1&idx=0&textlen=10&tk=3|3&client=t&prev=input&ttsspeed=1

		# Google recons automatic scripting attemps. Maybe this helps.
		time.sleep(2)

		# Build the main query
		strMainQuery = urllib.urlencode({"q": strText, "tl":strLanguageGoogle})	

		# Ask to read it 
		fResponse = objUrlOpener.open("https://translate.google.de/translate_tts?ie=UTF-8&" + strMainQuery + "&total=1&idx=0&textlen=10&tk=3|3&client=t&prev=input&ttsspeed=1")

		# Write it to file
		with open(strDestinationPath, "wb") as out:
			out.write(fResponse.read())

		if b32kHz:
			subprocess.check_output(["lame","-V2","-a","--vbr-new","--resample","32",strDestinationPath,strDestinationPath + "_resampled"])
			subprocess.check_output(["rm",strDestinationPath])
			subprocess.check_output(["mv",strDestinationPath + "_resampled",strDestinationPath])

	elif strRobot == "Linguatec": # ------------------------------------------------------
		# http://www.linguatec.de/onlineservices/vrs15_getmp3?text=Hallo%20Heinz,%0A%0Awie%20geht%27s%20?&voiceName=Anna-ml&speakSpeed=100&speakPith=100&speakVolume=100
		# <xml>
		#  <audio>http://vrs15.linguatec.org/VRS15OnlineWebService/Files/569ab711-f839-4e1f-aac5-31f625501897.mp3</audio>
		# </xml>


		# Build the main query
		strMainQuery = urllib.urlencode({"text": strText})	

		# Ask to read it
		fResponse = objUrlOpener.open("http://www.linguatec.de/onlineservices/vrs15_getmp3?" + strMainQuery + "&voiceName=Anna-ml&speakSpeed=100&speakPith=100&speakVolume=100")
				
		# Ask for the MP3 file itself
		strResponse = fResponse.read()
		strMainQuery = filterOutText(strResponse,"<audio>","</audio>")

		fResponse = objUrlOpener.open(strMainQuery)
		
		# Write it to file
		with open(strDestinationPath, "wb") as out:
			out.write(fResponse.read())
			
		if b32kHz:
			subprocess.check_output(["lame","-V2","-a","--vbr-new","--resample","32",strDestinationPath,strDestinationPath + "_resampled"])
			subprocess.check_output(["rm",strDestinationPath])
			subprocess.check_output(["mv",strDestinationPath + "_resampled",strDestinationPath])		

	elif strRobot == "Apple": # ------------------------------------------------------
		# say -v anna -o vorgelesen.aiff "Hallo Du ei" && lame -V2 -a --vbr-new --resample 32 vorgelesen.aiff test.mp3
		subprocess.check_output(["say","-v","anna","-o",strDestinationPath + ".aiff", "\"" + strText + "\""])
		
		# .aiff to .mp3
		if b32kHz:
			subprocess.check_output(["lame","-V2","-a","--vbr-new","--resample","32",strDestinationPath + ".aiff",strDestinationPath])
		else:
			subprocess.check_output(["lame","-V2","-a","--vbr-new",                  strDestinationPath + ".aiff",strDestinationPath])

		# remove .aiff
		subprocess.check_output(["rm",strDestinationPath + ".aiff"])
	

# ----------------------------------------------------------------------------
# List all files or folders under a specific folder
# ----------------------------------------------------------------------------
def listFiles(strPath,strFilesOrFolders):
	strShell = subprocess.check_output(["ls","-p1",strPath])
	cObjects = strShell.split("\n")
	cFiles = []
	cFolders = []

	for strObject in cObjects:
		if len(strObject)>0:
			if strObject[len(strObject)-1]=="/":
				cFolders.append(strObject[:len(strObject)-1])
			else:
				cFiles.append(strObject)

	if strFilesOrFolders == "Files":
		return cFiles
	else:
		return cFolders


# ########################### Main Programm ######################################

if strPrepareAction == "Booktitles on Stick": ########################
	# read the booktitles in the books folders as 000.mp3 -----
	cFolders = listFiles(strBooksFolder,"Folders")
	for numBook in range(len(cFolders)):
		strBook = cFolders[numBook]
		readAsMP3(strBook,strBooksFolder + strBook + "/" + "000.mp3", b32kHz, strReadRobot)

		# read waitbar percent
		strPercent = str(int((float(numBook) / len(cFolders)) * 100))
# 		play(strText2SpeechFolder + str(strPercent).zfill(3),"end")
# 		play(strText2SpeechFolder + "Percent","end")
		print strPercent,"%"
	
	# put a marker, that it is ready
	subprocess.check_output(["touch",strBooksFolder + strUSBStickPrepared])


elif strPrepareAction == "General Voiceoutputs": ##########################
	try:
		subprocess.check_output(["mkdir",strText2SpeechFolder])
	except:
		pass

	try:
		subprocess.check_output(["mkdir",strText2SpeechFolder + "num/"])
	except:
		pass


	# read the texts ---------------
	dictTextsToSpeak = {
	"Percent" :"Prozent",
	# "Pause"   :"Pause",
	# "Unpause" :"Weiterlesen",
	"Shutdown":"Bitte in 60 Sekunden den Schnurschalter betätigen"
	}

	for strKey in dictTextsToSpeak.iterkeys():
		readAsMP3(dictTextsToSpeak[strKey], strText2SpeechFolder + strKey + ".mp3", b32kHz, strReadRobot)

	# read the numbers ----------------
	dictTextsToSpeak = {}
	for numNumbers in range(0,1000):
		strNumber = str(numNumbers)
		dictTextsToSpeak.update({strNumber.zfill(3):strNumber})

	for strKey in dictTextsToSpeak.iterkeys():
		readAsMP3(dictTextsToSpeak[strKey], strText2SpeechFolder + "num/" + strKey + ".mp3", b32kHz, strReadRobot)



